23b39ac8783a9eff087a2cf587c2b1280044714c
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8
9 # {{{ path, variables, signals, umask, zsh
10 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
11 DEBUG="/dev/null"
12 KERNEL="$(uname -r)"
13 ARCH="$(uname -m)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 # {{{ Read in boot parameters
37 if [ -z "$CMDLINE" ]; then
38   # if CMDLINE was set from the outside, we're debugging.
39   # otherwise, take CMDLINE from Kernel and config files.
40   CMDLINE="$(cat /proc/cmdline)"
41   [ -d /cdrom/bootparams/ ]      && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
42   [ -d /live/image/bootparams/ ] && CMDLINE="$CMDLINE $(cat /live/image/bootparams/* | tr '\n' ' ')"
43 fi
44 # }}}
45
46 ### {{{ Utility Functions
47
48 # Get a bootoption's parameter: read boot command line and either
49 # echo last parameter's argument or return false.
50 getbootparam(){
51   local line
52   local ws
53   ws='   '
54   line=" $CMDLINE "
55   case "$line" in
56     *[${ws}]"$1="*)
57       result="${line##*[$ws]$1=}"
58       result="${result%%[$ws]*}"
59       echo "$result"
60       return 0 ;;
61     *) # no match?
62       return 1 ;;
63   esac
64 }
65
66 # Check boot commandline for specified option
67 checkbootparam(){
68   [ -n "$1" ] || ( echo "Error: missing argument to checkbootparam()" ; return 1 )
69   local line
70   local ws
71   ws='   '
72   line=" $CMDLINE "
73   case "$line" in
74     *[${ws}]"$1"=*|*[${ws}]"$1"[${ws}]*)
75       return 0 ;;
76     *)
77       return 1 ;;
78   esac
79 }
80
81 # Check if currently using a framebuffer
82 hasfb() {
83     [ -e /dev/fb0 ] && return 0 || return 1
84 }
85
86 # Check wheter a configuration variable (like $CONFIG_TOHD) is
87 # enabled or not
88 checkvalue(){
89   case "$1" in
90     [yY][eE][sS])     return 0 ;; # it's set to 'yes'
91     [tT][rR][uU][eE]) return 0 ;; # it's set to 'true'
92                    *) return 1 ;; # default
93   esac
94 }
95
96 # Are we using grml-small?
97 checkgrmlsmall(){
98   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
99 }
100
101 # execute flite only if it's present
102 flitewrapper() {
103    [ -x /usr/bin/flite ] && flite -o play -t "$*"
104 }
105 ### }}}
106
107 # {{{ filesystems (proc, pts, sys) and fixes
108 mount_proc(){
109   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
110 }
111
112 mount_pts(){
113   grep -q "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
114 }
115
116 mount_sys(){
117   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
118 }
119 # }}}
120
121 # {{{ Check if we are running in live mode or from HD
122 INSTALLED=""
123 [ -e /etc/grml_cd ] || INSTALLED="yes"
124
125 # testcd
126 TESTCD=""
127 checkbootparam 'testcd' >>$DEBUG 2>&1 && TESTCD="yes"
128 # }}}
129
130 # {{{ source lsb-functions , color handling
131 if checkbootparam 'nocolor'; then
132   RC_NOCOLOR=yes
133   . /etc/grml/lsb-functions
134   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
135 else
136   . /etc/grml/lsb-functions
137   . /etc/grml_colors
138 fi
139 # }}}
140
141 # {{{ debug
142 config_debug(){
143  checkbootparam 'debug'            && BOOTDEBUG="yes"
144  checkbootparam "BOOT_IMAGE=debug" && BOOTDEBUG="yes"
145
146  rundebugshell(){
147   if [ -n "$BOOTDEBUG" ]; then
148      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
149      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
150         einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
151         einfo "Just exit the shell to continue boot process..."
152         /bin/zsh
153      else
154         eindent
155         if [ -r /etc/grml/screenrc ] ; then
156            einfo "Starting GNU screen to be able to use a full featured shell environment."
157            einfo "Just exit the shells (and therefore screen) to continue boot process..."
158            /bin/zsh -c "screen -c /etc/grml/screenrc"
159         else
160            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
161            einfo "Just exit the shell to continue boot process..."
162            /bin/zsh
163         fi
164         eoutdent
165      fi
166   fi
167  }
168 }
169 # }}}
170
171 # {{{ log
172 config_log(){
173 if checkbootparam 'log' || checkbootparam 'debug' ; then
174    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
175    touch $DEBUG
176    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
177    eindent
178      einfo "Starting bootlogd." # known to be *very* unreliable :(
179      bootlogd -r -c >>$DEBUG 2>&1 ; eend $?
180    eoutdent
181 else
182    DEBUG="/dev/null"
183 fi
184 }
185 # }}}
186
187 # {{{ set firmware timeout via bootparam
188 config_fwtimeout(){
189  if checkbootparam 'fwtimeout' ; then
190    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
191    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
192    rmmod firmware_class >>$DEBUG 2>&1
193    modprobe firmware_class ; eend $?
194  fi
195  if [ -z "$TIMEOUT" ] ; then
196    TIMEOUT="100" # linux kernel default: 10
197  fi
198  if [ -f /sys/class/firmware/timeout ] ; then
199    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
200    echo 100 > /sys/class/firmware/timeout ; eend $?
201  fi
202 }
203 # }}}
204
205 ### {{{ language configuration / localization
206 config_language(){
207
208  einfo "Activating language settings:"
209  eindent
210
211  # people can specify $LANGUAGE and $CONSOLEFONT in a config file
212  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
213
214  # check for bootoption which overrides config from /etc/grml/autoconfig
215  BOOT_LANGUAGE="$(getbootparam 'lang' 2>>$DEBUG)"
216  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
217
218  # set default to 'en' in live-cd mode iff $LANGUAGE is not set yet
219  if [ -z "$INSTALLED" ] ; then
220     [ -n "$LANGUAGE" ] || LANGUAGE='en'
221  fi
222
223  if [ -x /usr/sbin/grml-setlang ] ; then
224    # if bootoption lang is used update /etc/default/locale accordingly
225    if [ -n "$BOOT_LANGUAGE" ] ; then
226      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "$LANGUAGE"
227    # otherwise default to lang=en
228    else
229      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "en"
230    fi
231  fi
232
233  # set console font
234  if [ -z "$CONSOLEFONT" ] ; then
235     if ! checkbootparam 'nodefaultfont' >>$DEBUG 2>&1 ; then
236        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
237           CONSOLEFONT='Uni3-Terminus16'
238        else
239           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
240        fi
241        if ! hasfb ; then
242           CONSOLEFONT='Lat15-Terminus16'
243        fi
244     fi
245  fi
246
247  # export it now, so error messages get translated, too
248  if checkgrmlsmall ; then
249     export LANG='C' # grml-small does not provide any further locales
250  else
251     [ -r /etc/default/locale ] && . /etc/default/locale
252     export LANG LANGUAGE
253  fi
254
255  # configure keyboard layout, read in already set values first:
256  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
257
258  # now allow keyboard override by boot commandline for later use:
259  KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
260  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
261  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
262  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
263  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
264
265  # modify /etc/sysconfig/keyboard only in live-cd mode:
266  if [ -z "$INSTALLED" ] ; then
267
268    local LANGUAGE="$BOOT_LANGUAGE"
269    . /etc/grml/language-functions
270    # allow setting xkeyboard explicitly different than console keyboard
271    KXKEYBOARD="$(getbootparam 'xkeyboard' 2>>$DEBUG)"
272    if [ -n "$KXKEYBOARD" ]; then
273       XKEYBOARD="$KXKEYBOARD"
274       KDEKEYBOARD="$KXKEYBOARD"
275    elif [ -n "$KKEYBOARD" ]; then
276       XKEYBOARD="$KKEYBOARD"
277       KDEKEYBOARD="$KKEYBOARD"
278    fi
279
280    # duplicate of previous code to make sure /etc/grml/language-functions
281    # does not overwrite our values....
282    # now allow keyboard override by boot commandline for later use:
283    KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
284    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
285    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
286    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
287    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
288
289    # write keyboard related variables to file for later use
290    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
291    if ! [ -e /etc/sysconfig/keyboard ] ; then
292       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
293       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
294       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
295       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
296    fi
297  fi
298
299  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
300
301  # activate unicode console if running within utf8 environment
302  if [ -r /etc/default/locale ] ; then
303     if grep -q "LANG=.*UTF" /etc/default/locale ; then
304        einfo "Setting up unicode environment."
305        unicode_start >>$DEBUG 2>&1 ; eend $?
306     fi
307  fi
308
309  # Set default keyboard before interactive setup
310  if [ -n "$KEYTABLE" ] ; then
311     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
312     loadkeys -q $KEYTABLE &
313     eend $?
314  fi
315
316  # we have to set up all consoles, therefore loop it over all ttys:
317  NUM_CONSOLES=$(fgconsole --next-available 2>/dev/null)
318  if [ -n "$NUM_CONSOLES" ] ; then
319     NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
320     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
321  fi
322  CUR_CONSOLE=$(fgconsole 2>/dev/null)
323  if [ -n "$CHARMAP" ] ; then
324     einfo "Running consolechars for ${CHARMAP}"
325     RC=0
326     for vc in $(seq 0 ${NUM_CONSOLES}) ; do
327         consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
328     done
329     if [ -n "$CUR_CONSOLE" ] ; then
330        [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
331     fi
332     eend $RC
333  fi
334
335  if checkbootparam 'noconsolefont' ; then
336     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
337  else
338     if [ -n "$CONSOLEFONT" ] ; then
339        einfo "Running consolechars using ${CONSOLEFONT}"
340        RC=0
341        for vc in $(seq 0 ${NUM_CONSOLES}) ; do
342            consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT ; RC=$?
343        done
344        if [ -n "$CUR_CONSOLE" ] ; then
345           [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
346        fi
347        eend $RC
348     fi
349  fi
350
351  eoutdent
352 }
353 # }}}
354
355 # {{{ Set hostname
356 config_hostname(){
357  if checkbootparam 'hostname' ; then
358   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
359   if [ -z "$HOSTNAME" ] && [ -x /usr/bin/random-hostname ] ; then
360      einfo "Generating random hostname as no hostname was specified."
361      HOSTNAME="$(/usr/bin/random-hostname)"
362      eend $?
363   fi
364   einfo "Setting hostname to $HOSTNAME as requested."
365   grml-hostname $HOSTNAME >>$DEBUG ; RC=$?
366   [ "$RC" = "0" ] && hostname $HOSTNAME
367   eend $RC
368  else
369   hostname --file /etc/hostname
370  fi
371 }
372 # }}}
373
374 # fstabuser (needed when running from harddisk with username != grml {{{
375 config_userfstab(){
376   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
377   if [ -n "$CONFIG_FSTAB_USER" ] ; then
378      fstabuser="$CONFIG_FSTAB_USER"
379   else
380      fstabuser=$(getent passwd 1000 | cut -d: -f1)
381   fi
382   # if not yet set fall back to default 'grml' user
383   [ -n "$fstabuser" ] || fstabuser='grml'
384 }
385 # }}}
386
387 # {{{ Set clock (Local time is more often used than GMT, so it is default)
388 config_time(){
389  # don't touch the files if running from harddisk:
390  if [ -z "$INSTALLED" ]; then
391     # The default hardware clock timezone is stated as representing local time.
392     UTC="--localtime"
393     grep -q "^UTC=" /etc/default/rcS || echo "UTC=no" >> /etc/default/rcS
394     checkbootparam 'utc'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
395     checkbootparam 'gmt'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
396     checkbootparam 'localtime' >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=no|"  /etc/default/rcS
397     grep -q -i "^UTC=yes" /etc/default/rcS && UTC="-u"
398     # hwclock uses the TZ variable
399     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
400     [ -z "$KTZ" ] && [ -r /etc/timezone ] && KTZ=$(cat /etc/timezone)
401     if [ ! -f "/usr/share/zoneinfo/$KTZ" ] ; then
402        ewarn "Warning: unknown timezone $KTZ" ; eend 1
403        KTZ="Europe/Vienna"
404        ewarn "Falling back to timezone $KTZ" ; eend 0
405     fi
406
407     if ! [ -r /dev/rtc ] ; then
408       ewarn "Warning: realtime clock not available, trying to execute hwclock anyway." ; eend 0
409     fi
410
411     ERROR=$(TZ="$KTZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
412     if [ -n "$ERROR" ] ; then
413        eindent
414        ERROR=$(TZ="$KTZ" hwclock $UTC -s --directisa 2>&1 | head -1)
415        if [ -n "$ERROR" ] ; then
416           eerror "Problem running hwclock: $ERROR" ; eend 1
417        fi
418        eoutdent
419     fi
420
421  fi
422 }
423 # }}}
424
425 # {{{ print kernel info
426 config_kernel(){
427   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
428   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
429   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
430   if [ -r /proc/cpuinfo ] ; then
431      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
432        eindent
433        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
434        eoutdent
435      fi
436   fi
437   if [ -d /proc/xen ] ; then
438      eindent
439      einfo 'Running kernel featuring support for Xen detected' ; eend 0
440      eoutdent
441   fi
442 }
443 # }}}
444
445 # {{{ vmware specific stuff
446 config_vmware(){
447 if checkbootparam 'novmware' ; then
448    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
449 else
450    if [ -z "$INSTALLED" ] ; then
451       if vmware-detect || checkbootparam "BOOT_IMAGE=vmware" ; then
452          if ! checkbootparam 'qemu' ; then
453             if [ -r /etc/X11/xorg.conf.vmware ] ; then
454                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
455                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
456             fi
457          fi
458       elif [ -r /proc/acpi/battery/BAT0/info -a -r /etc/X11/xorg.conf.virtualbox ] ; then
459          if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
460             einfo 'Virtual Box: Copying /etc/X11/xorg.conf.virtualbox to /etc/X11/xorg.conf'
461             cp /etc/X11/xorg.conf.virtualbox /etc/X11/xorg.conf ; eend $?
462          fi
463       fi
464    fi
465 fi
466 }
467 # }}}
468
469 # {{{ qemu specific stuff
470 config_qemu(){
471 if checkbootparam 'qemu' ; then
472    if [ -r /etc/X11/xorg.conf.example ] ; then
473       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
474       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
475    fi
476 fi
477 }
478 # }}}
479
480 # {{{ ld.so.cache + depmod
481 config_ld_mod(){
482 if [ -n "$INSTALLED" ]; then
483  if ! [ -r /etc/grml.first.boot ] ; then
484   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
485   eindent
486 # Regenerate ld.so.cache and module dependencies on HD
487     einfo "Running ldconfig" ; ldconfig  ; eend $?
488     einfo "Running depmod"   ; depmod -a ; eend $?
489     touch /etc/grml.first.boot
490     eend 0
491   eoutdent
492  fi
493 fi
494 }
495 # }}}
496
497 # {{{ timezone
498 config_timezone(){
499  # don't touch the files if running from harddisk:
500  if [ -z "$INSTALLED" ]; then
501     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
502     if [ -n "$KTZ" ] ; then
503        if [ ! -f "/usr/share/zoneinfo/$KTZ" ]
504        then
505           ewarn "Warning: unknown timezone $KTZ"; eend 0
506        else
507           einfo "Setting timezone."
508           # update debconf
509           area=$(echo $KTZ | cut -d '/' -f1)
510           zone=$(echo $KTZ | cut -d '/' -f2)
511           echo "tzdata tzdata/Areas       select $area" | debconf-set-selections
512           echo "tzdata tzdata/Zones/$area select $zone" | debconf-set-selections
513           # update files
514           echo $KTZ > /etc/timezone
515           rm -f /etc/localtime
516           cp "/usr/share/zoneinfo/$KTZ" /etc/localtime ; eend $?
517        fi
518     fi
519  fi
520 }
521 # }}}
522
523 # small computer / nearly no ram {{{
524 config_small(){
525
526 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
527 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
528 eindent
529
530 if checkbootparam 'small'; then
531   einfo "Information: ${RAM} kB of RAM available." ; eend 0
532   einfo "Bootoption small detected. Activating small system."
533   if [ -r /etc/inittab.small ] ; then
534     mv /etc/inittab /etc/inittab.normal
535     mv /etc/inittab.small /etc/inittab
536   else
537     sed -i 's/^9/#&/' /etc/inittab
538     sed -i 's/^10/#&/' /etc/inittab
539     sed -i 's/^11/#&/' /etc/inittab
540     sed -i 's/^12/#&/' /etc/inittab
541   fi
542   /sbin/telinit q ; eend $?
543 else
544   if checkgrmlsmall ; then
545     if [[ $RAM -lt 25000 ]] ; then
546       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
547       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
548       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
549       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
550       /bin/zsh --login
551     else
552       einfo "Information: ${RAM} kB of RAM available." ; eend 0
553     fi
554   else
555     if [[ $RAM -lt 58000 ]] ; then
556       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
557       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
558       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
559       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
560       /bin/zsh --login
561     else
562       einfo "Information: ${RAM} kB of RAM available." ; eend 0
563     fi
564   fi
565 fi
566 eoutdent
567 }
568 # }}}
569
570 # skip startup of w3m {{{
571 config_fast(){
572 if checkbootparam 'fast'; then
573   ewarn "Bootoption fast detected. Skipping startup of grml-quickconfig."
574     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
575   /sbin/telinit q ; eend $?
576 fi
577 }
578 # }}}
579
580 # activate serial console {{{
581 config_console(){
582 if checkbootparam 'console'; then
583   local line
584   local ws
585   ws='   '
586
587   einfo "Bootoption for serial console detected:"
588
589   line="$CMDLINE x "
590   this=""
591   line="${line#*[$ws]}"
592   local telinitq=""
593   while [ -n "$line" ]; do
594     case "$this" in
595       console=*)
596         local serial="$this"
597         local device="${this%%,*}"
598         local device="${device##*=}"
599         if echo $serial | grep -q ttyS ; then
600           local option="${serial##*,}"
601           # default (works for kvm & CO):
602           local speed="115200,57600,38400,19200,9600,4800,2400,1200";
603           # ... unless overriden by command line:
604           case "$option" in
605             115200*) speed=115200 ;;
606              57600*) speed=57600 ;;
607              38400*) speed=38400 ;;
608              19200*) speed=19200 ;;
609               9600*) speed=9600 ;;
610               4800*) speed=4800 ;;
611               2400*) speed=2400 ;;
612               1200*) speed=1200 ;;
613           esac
614           eindent
615             einfo "Activating console login on device ${device} with speed ${speed}."
616             local number="${device#ttyS}"
617             sed -i "/^T$number:/d;/^#grmlserial#/iT$number:23:respawn:/bin/bash -c \"/sbin/getty -L $device -l /usr/bin/zsh-login $speed vt100 || sleep 30\"" /etc/inittab
618             eend $?
619             telinitq="1"
620           eoutdent
621         fi
622         ;;
623     esac
624     this="${line%%[$ws]*}"
625     line="${line#*[$ws]}"
626   done
627
628   if [ -n "$telinitq" ]; then
629     /sbin/telinit q
630   fi
631   eend $?
632 fi
633 }
634 # }}}
635
636 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
637 config_cdrom_perm(){
638 CDROMS=""
639 for DEVICE in /proc/ide/hd?; do
640  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
641 done
642 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
643 }
644 # }}}
645
646 # {{{ Bring up loopback interface now
647 config_local_net(){
648  if [ -z "$INSTALLED" ] ; then
649     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
650        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
651     else
652        ifconfig lo up
653     fi
654  fi
655 }
656 # }}}
657
658 # firewire devices {{{
659 # the raw1394 driver does not yet export info into SYSFS,
660 # so let's create raw1394 device manually
661 # http://www.michael-prokop.at/blog/index.php?p=352
662 config_firewire_dev(){
663 if checkbootparam 'nofirewiredev' ; then
664   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
665 else
666 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
667   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
668 #  cd /dev && MAKEDEV video1394 raw1394
669   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
670   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
671 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
672   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
673   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
674   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
675 fi
676 #fi
677 }
678 # }}}
679
680 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
681 # otherwise we will get: passwd: Authentication token lock busy
682 config_fix_passwd(){
683  if [ -z "$INSTALLED" ] ; then
684   touch /etc/.pwd.lock
685  fi
686 }
687 # }}}
688
689 # {{{ CD Checker
690 config_testcd(){
691 if [ -n "$TESTCD" ]; then
692    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
693    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
694    echo -n "${RED}"
695
696    if [ -n "${LIVECD_PATH}"/GRML ] ; then
697       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
698    else
699       echo "${RED} *** Error: Could not find md5sum file.                           ***"
700    fi
701
702    if [ "$RC" = "0" ]; then
703       einfo "Everything looks OK" ; eend 0
704    else
705       eerror 'Checksum failed for theses files:' ; eend 1
706       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
707       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
708       eerror '... RAM of your computer is broken.' ; eend 1
709       einfon "Hit return to continue, or press the reset button to quit."
710      read a
711    fi
712
713    eend 0
714 fi
715 }
716 # }}}
717
718 # {{{ hardware detection via discover
719 config_discover(){
720 if checkbootparam 'nodisc' ; then
721   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
722 else
723  if [ -x /sbin/discover ] ; then
724   einfo "Discovering hardware. Trying to load the following modules in background:"
725    eindent
726    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
727    eoutdent
728   /sbin/discover-modprobe -v >>$DEBUG 2>&1 &
729   eend 0
730  else
731   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
732  fi
733 fi
734 }
735 # }}}
736
737 # {{{ hardware detection via hwinfo
738 config_hwinfo(){
739 if checkbootparam 'hwinfo' >>$DEBUG 2>&1; then
740   einfo "Discovering hardware via hwinfo:"
741   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
742   echo -n "  Loading modules: "
743   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
744   eend 0
745 fi
746 }
747 # }}}
748
749 # {{{ disable hotplug agents on request
750 config_hotplug_agent(){
751 if checkbootparam 'noagent' ; then
752   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
753   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
754   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
755   einfo "Disabling hotplug-agent(s) $AGENTNL"
756   for agent in $(echo -e $AGENTLIST) ; do
757     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
758   done
759   [ "$?" == "0" ] ; eend $?
760 fi
761 }
762 # }}}
763
764 # {{{ blacklist of hotplug-modules
765 config_hotplug_blacklist(){
766 if checkbootparam 'black' ; then
767   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
768   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
769   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
770   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
771   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
772   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
773   eend 0
774 fi
775 }
776 # }}}
777
778 # {{{ run hotplug
779 config_hotplug(){
780 if checkbootparam 'nohotplug' ; then
781   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
782 else
783   if [ -r /etc/init.d/hotplug ] ; then
784     einfo "Starting hotplug system in background."
785     /etc/init.d/hotplug start >>$DEBUG 2>>$DEBUG &
786     eend 0
787   elif [ -r /etc/init.d/hotplug-light ] ; then
788     einfo "Starting hotplug-light system in background."
789     /etc/init.d/hotplug-light start >>$DEBUG 2>>$DEBUG &
790     eend 0
791   else
792     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
793   fi
794 fi
795 }
796 # }}}
797
798 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
799 config_blacklist(){
800 if checkbootparam 'blacklist' ; then
801  if [ -z "$INSTALLED" ]; then
802   einfo "Bootoption blacklist found."
803   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
804   BLACKLIST_FILE='/etc/modprobe.d/grml.conf'
805   if [ -n "$BLACK" ] ; then
806     for module in $(echo ${BLACK//,/ }) ; do
807         einfo "Blacklisting module ${module} via ${BLACKLIST_FILE}."
808         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE"
809         echo "blacklist $module"     >> "$BLACKLIST_FILE"
810         echo "alias     $module off" >> "$BLACKLIST_FILE"
811         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE" ; eend $?
812     done
813   else
814    eerror "No given module for blacklist found. Blacklisting will not work therefore."
815   fi
816  else
817   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
818   eindent
819    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
820   eoutdent
821  fi
822 fi
823 }
824 # }}}
825
826 # {{{ ACPI
827 config_acpi_apm(){
828 if [ -d /proc/acpi ]; then
829   if checkbootparam 'noacpi'; then
830     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
831   elif checkbootparam 'nogrmlacpi' ; then
832     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
833   else
834     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
835     eindent
836     found=""
837     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
838       basename="${a##*/}"
839       basename="${basename%%.*}"
840       case "$basename" in *_acpi)
841        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
842       esac
843       modprobe $basename >>$DEBUG 2>&1 && found="yes"
844       local BASE="$BASE $basename"
845     done
846     if [ -n "$found" ] ; then
847       einfo "$BASE"  ; eend 0
848     else
849       ewarn "(none)" ; eend 1
850     fi
851     if ! ps x | grep -q /usr/sbin/acpid ; then
852       if ! [ -r /var/run/dbus/pid ] ; then
853         einfo "Starting acpi daemon."
854         /etc/init.d/acpid start >>$DEBUG 2>&1 ; eend $?
855       else
856         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
857         eerror "Solution: please activate acpid via /etc/runlevel.conf"
858         eend 1
859       fi
860     else
861       ewarn "acpi daemon already running."
862       eend 0
863     fi
864     eoutdent
865   fi
866 else
867 # APM
868   if checkbootparam 'noapm'; then
869     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
870   else
871     modprobe apm power_off=1 >>$DEBUG 2>&1
872     if [ "$?" = "0" ] ; then
873        if [ -x /etc/init.d/apmd ] ;then
874           einfo "APM Bios found, enabling power management functions."
875           /etc/init.d/apmd start ; eend $?
876        fi
877     else
878       eerror "Loading apm module failed." ; eend 1
879     fi
880   fi
881 fi
882 }
883 # }}}
884
885 # {{{ PCMCIA Check/Setup
886 # This needs to be done before other modules are being loaded (by hwsetup)
887 config_pcmcia(){
888 if checkbootparam 'nopcmcia'; then
889   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
890 else
891   if /usr/sbin/laptop-detect ; then
892     einfo "Detected Laptop - checking for PCMCIA." && eend 0
893     modprobe pcmcia_core >>$DEBUG 2>&1
894     # Try Cardbus or normal PCMCIA socket drivers
895     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
896     if [ "$?" = "0" ]; then
897       modprobe ds >>$DEBUG 2>&1
898       if [ -d /proc/bus/pccard ] ; then
899        if [ -x /sbin/cardmgr ] ; then
900         einfo "PCMCIA found, starting cardmgr."
901         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
902        else
903         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
904        fi
905       fi
906     fi
907   fi
908 fi
909 }
910 # }}}
911
912 # {{{ run software synthesizer via speakup
913 config_swspeak(){
914    if checkbootparam 'swspeak' ; then
915       einfo "Bootoption swspeak found."
916
917       if [ ! -d /proc/speakup/ ] && ! grep -q speakup_soft /proc/modules ; then
918          ewarn "Kernel does not support software speakup - trying to load kernel module:" ; eend 0
919          eindent
920          einfo "Loading speakup_soft"
921          if modprobe speakup_soft ; then
922             eend 0
923          else
924             flitewrapper "Fatal error setting up software speakup"
925             eend 1
926             return 1
927          fi
928          eoutdent
929       fi
930
931       if [ -d /proc/speakup/ ] || grep -q speakup_soft /proc/modules ; then
932          einfo "Kernel supports speakup." ; eend 0
933          eindent
934             einfo "Just run swspeak if you want to use software synthesizer via speakup."
935             flitewrapper "Finished activating software speakup. Just run swspeak when booting finished."
936          eoutdent
937       else
938          eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
939          flitewrapper "Kernel does not seem to support speakup. Sorry."
940       fi
941    fi
942 }
943 # }}}
944
945 # {{{ support hardware synthesizer via speakup
946 config_hwspeak(){
947    if checkbootparam 'speakup.synth' ; then
948       einfo "Bootoption speakup.synth found."
949       eindent
950
951       module="$(getbootparam 'speakup.synth' 2>>$DEBUG)"
952       if [ -z "$module" ] ; then
953          eerror "Sorry, no speakup module specified for bootoption speakup.synth."
954          flitewrapper "Sorry, no speakup module specified for bootoption speakup.synth."
955       else
956          einfo "Trying to load $module"
957          modprobe "speakup_${module}"
958          eend $?
959       fi
960
961       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
962          einfo "Kernel should support speakup now." ; eend 0
963          flitewrapper "Kernel should support speakup now."
964       else
965          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
966          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
967       fi
968
969       eoutdent
970
971    # hwspeak:
972    elif checkbootparam 'hwspeak' ; then
973       einfo "Bootoption hwspeak found."
974
975       if [ ! -d /proc/speakup/ ] && ! grep -q speakup /proc/modules ; then
976          ewarn "Kernel does not support hardware speakup - trying to load kernel modules:" ; eend 0
977          eindent
978          if ! [ -d "/lib/modules/${KERNEL}/extra/speakup/" ] ; then
979             eerror "Kernel does not provide speakup modules, sorry." ; eend 1
980          else
981            for module in $(find "/lib/modules/${KERNEL}/extra/speakup/" -name \*.ko | \
982                            sed 's#.*speakup/##g ; s#.ko$##g' | \
983                            grep -ve speakup_soft -ve speakup_dummy | sort -u) ; do
984               einfo "Trying to load $module"
985               modprobe $module
986               eend $?
987            done
988          fi
989          eoutdent
990       fi
991
992       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
993          einfo "Kernel should support speakup now." ; eend 0
994          flitewrapper "Kernel should support speakup now."
995       else
996          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
997          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
998       fi
999    fi
1000 }
1001 # }}}
1002
1003 # {{{ Check for blind option or brltty
1004 config_blind(){
1005 BLIND=""
1006 checkbootparam 'blind' && BLIND="yes"
1007 BRLTTY="$(getbootparam 'brltty' 2>>$DEBUG)"
1008
1009 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
1010   if [ -x /sbin/brltty ]; then
1011     # Blind option detected, start brltty now.
1012     # modprobe serial_core parport_serial generic_serial && echo "done"
1013     CMD=brltty
1014     BRLTYPE=""
1015     BRLDEV=""
1016     BRLTEXT=""
1017     if [ -n "$BRLTTY" ]; then
1018       # Extra options
1019       BRLTYPE="${BRLTTY%%,*}"
1020       R="${BRLTTY#*,}"
1021       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1022         BRLTTY="$R"
1023         BRLDEV="${BRLTTY%%,*}"
1024         R="${BRLTTY#*,}"
1025         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1026           BRLTTY="$R"
1027           BRLTEXT="${BRLTTY%%,*}"
1028           R="${BRLTTY#*,}"
1029         fi
1030       fi
1031     fi
1032     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
1033     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
1034     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
1035     einfo "Starting braille-display manager."
1036 #    ( exec $CMD & )
1037     ( sh -c "$CMD" & )
1038     sleep 2 && BLINDSOUND="yes"
1039     eend 0
1040   fi
1041 fi
1042 }
1043 # }}}
1044
1045 # {{{ Interactive configuration
1046 config_interactive(){
1047   ewarn "config_interactive is deprecated nowadays."
1048   ewarn "Please set CONFIG_INTERACTIVE='no' in /etc/grml/autoconfig" ; eend 0
1049 }
1050 # }}}
1051
1052 # {{{ AGP
1053 config_agp(){
1054 if checkbootparam 'forceagp' ; then
1055 # Probe for AGP. Hope this can fail safely
1056   grep -q "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
1057 fi
1058 }
1059 # }}}
1060
1061 # {{{ automount(er)
1062 config_automounter(){
1063 if checkbootparam 'automounter' ; then
1064   RUNLEVEL="$(runlevel)"
1065   AUTOMOUNTER=""
1066   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
1067
1068 addautomount(){
1069 # /dev/ice  options
1070   d="${1##*/}"
1071   if [ -n "$AUTOMOUNTER" ]; then
1072     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
1073     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
1074     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
1075     anew="$d        -fstype=auto,$2 :$i"
1076     grep -q "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
1077     AUTOMOUNTS="$AUTOMOUNTS $d"
1078     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
1079   else
1080     [ -d /mnt/$d ] && mkdir -p /mnt/$d
1081     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
1082   fi
1083   grep -q "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
1084 }
1085
1086   AUTOMOUNTS="floppy cdrom"
1087 # Add new devices to /etc/fstab and /etc/auto.mnt
1088   for i in /dev/cdrom?*; do
1089     if [ -L $i ]; then
1090       addautomount "$i" "ro"
1091     fi
1092   done
1093 fi
1094
1095 if [ -n "$AUTOMOUNTER" ]; then
1096 # Check for floppy dir, reinstall with automounter
1097   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
1098   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
1099   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
1100   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
1101   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
1102   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
1103   rm -f /etc/fstab.new
1104 # Replace paths from bootfloppy
1105   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
1106   mv -f /etc/fstab.new /etc/fstab
1107 # Start automounter now
1108   einfo "Starting automounter for ${AUTOMOUNTS}."
1109   /etc/init.d/autofs start >>$DEBUG ; eend $?
1110 fi
1111 }
1112 # }}}
1113
1114 # {{{ Collect partitions from /proc/partitions first for enabling DMA
1115 check_partitions(){
1116 partitions=""
1117 IDEDISKS=""
1118 while read major minor blocks partition relax; do
1119   partition="${partition##*/}"
1120   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
1121   case "$partition" in
1122     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
1123     sd?) ;;                                               # SCSI Harddisk, entire disk
1124 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
1125     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
1126   esac
1127 done <<EOT
1128 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
1129 EOT
1130 }
1131 check_partitions >/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
1132 # }}}
1133
1134 # {{{ Enable DMA for all IDE drives now if not disabled
1135 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
1136 config_dma(){
1137 if checkbootparam 'nodma'; then
1138   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
1139 else
1140   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
1141     if test -d /proc/ide/$d; then
1142       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
1143         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
1144         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
1145         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
1146         echo "using_dma:1" >/proc/ide/$d/settings
1147         eend 0
1148       fi
1149     fi
1150   done
1151 fi
1152 }
1153 # }}}
1154
1155 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
1156 config_fstab(){
1157
1158 NOSWAP="yes" # we do not use swap by default!
1159 if checkbootparam 'swap' || checkbootparam 'anyswap' ; then
1160    NOSWAP=''
1161    checkbootparam 'anyswap' && export ANYSWAP='yes' || export ANYSWAP=""
1162 fi
1163
1164 if checkbootparam 'nofstab' || checkbootparam 'forensic' ; then
1165   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1166 else
1167   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1168   iszsh && setopt nonomatch
1169   if [ -x /usr/sbin/rebuildfstab ] ; then
1170      config_userfstab || fstabuser=grml
1171      /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1172   else
1173      ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1174   fi
1175 fi # checkbootparam nofstab/forensic
1176
1177 # Scan for swap, config, homedir - but only in live-mode
1178 if [ -z "$INSTALLED" ] ; then
1179    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1180    GRML_IMG=""
1181    GRML_SWP=""
1182    HOMEDIR="$(getbootparam 'home')"
1183    if [ -n "$partitions" ]; then
1184       while read p m f relax; do
1185         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1186         partoptions="users,exec"
1187         fnew=""
1188         # it's a swap partition?
1189         case "$f" in swap)
1190           eindent
1191           if [ -n "$NOSWAP" ]; then
1192              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1193              eend 0
1194           else
1195              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1196                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1197                      if [ -n "$ANYSWAP" ] ; then
1198                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1199                         swapon $p 2>>$DEBUG ; eend $?
1200                      else
1201                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1202                      fi
1203                      ;;
1204                    *)
1205                      if [[ "$p" == LABEL* ]] ; then
1206                         p=$(blkid -t $p | awk -F: '{print $1}')
1207                      fi
1208                      if grep -q $p /proc/swaps ; then
1209                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1210                      else
1211                         if [ -b "$p" ] ; then
1212                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1213                         swapon $p 2>>$DEBUG ; eend $?
1214                         else
1215                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1216                         fi
1217                      fi
1218                      ;;
1219              esac # dd-check
1220           fi # -n "$NOSWAP
1221           eoutdent
1222           continue
1223           ;;
1224         esac # it's a swap partition?
1225
1226         # mount read-only
1227         MOUNTOPTS="ro"
1228         case "$f" in
1229           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1230           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1231           *) continue ;;
1232           # *) NONEFOUND='1'; continue ;;
1233         esac
1234
1235         # use a swapfile
1236         if [ -z "$NOSWAP" ] ; then
1237            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1238            # Activate swapfile, if exists
1239            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1240         fi
1241         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1242            mount -o remount,rw $m && MOUNTED=1
1243            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1244               eindent
1245                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1246               eoutdent
1247               fnew="$SWAPFILE swap swap defaults 0 0"
1248               grep -q "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1249               GRML_SWP="$GRML_SWP $SWAPFILE"
1250               eend 0
1251            fi
1252            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1253         fi
1254
1255         # use a image as home
1256         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1257         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1258            if [ -n "$HOMEDIR" ]; then
1259               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1260                  continue
1261               fi
1262            fi
1263            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1264               GRML_IMG="$IMAGE"
1265               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1266            fi
1267         fi
1268         eend 0
1269
1270         # Umount, if not in use
1271         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1272
1273       done <<EOT
1274       $(cat /etc/fstab)
1275 EOT
1276    fi # -n $partitions
1277 fi # -z $INSTALLED
1278 }
1279 # }}}
1280
1281 # {{{ Mouse
1282 config_mouse(){
1283 if [ -n "$MOUSE_DEVICE" ] ; then
1284   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1285 fi
1286 }
1287 # }}}
1288
1289 # {{{ IPv6 configuration
1290 # Load IPv6 kernel module and print IP adresses
1291 config_ipv6(){
1292 if checkbootparam 'ipv6'; then
1293   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1294   modprobe ipv6
1295   # we probably need some time until stateless autoconfiguration has happened
1296   sleep 2
1297   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1298   for DEVICE in `echo "$NETDEVICES"`; do
1299     eindent
1300       einfo "$DEVICE:"
1301       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1302       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1303       eindent
1304         for ADDR in `echo "$ADDRESSES"` ; do
1305             einfo "$ADDR"
1306         done
1307         if [ "$COUNT" -eq "0" ] ; then
1308            einfo "(none)" ; eend 1
1309         fi
1310       eoutdent
1311     eoutdent
1312   done
1313   eend 0
1314 fi
1315 }
1316 # }}}
1317
1318 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1319 config_dhcp(){
1320 if checkbootparam 'nodhcp'; then
1321   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1322 else
1323   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1324   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1325   for DEVICE in `echo "$NETDEVICES"` ; do
1326     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1327     trap 2 3 11
1328     ifconfig $DEVICE up >>$DEBUG 2>&1
1329     ( pump -i $DEVICE --script=/usr/lib/grml-autoconfig/pump-runparts >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1330     trap "" 2 3 11
1331     sleep 1
1332     eend 0
1333   done
1334   if [ -n "$INSTALLED" ] ; then
1335      ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
1336      eend 0
1337   fi
1338 fi
1339 }
1340 # }}}
1341
1342 # {{{ CPU-detection
1343 config_cpu(){
1344 if checkbootparam 'nocpu'; then
1345   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1346 else
1347   # check module dependencies
1348   cpufreq_check() {
1349    if ! [ -e /lib/modules/${KERNEL}/kernel/arch/x86/kernel/cpu/cpufreq ] ; then
1350       if [ -e /lib64 ] ; then
1351          [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1352       else
1353          [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1354       fi
1355    fi
1356   }
1357
1358   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1359      einfo "Detecting CPU:"
1360      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1361      echo $CPU | sed 's/ \{1,\}/ /g'
1362      eend 0
1363   else
1364      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1365   fi
1366
1367   # Disclaimer: sorry for the tons of if/then/else... but this makes sure we use:
1368   # * it only if we have the according kernel modules available
1369   # * cpufreq not inside Virtual Box
1370   # * current version of /etc/init.d/loadcpufreq from Debian (to stay in sync)
1371   #   -> parse output of the initscript and output it according to our look'n'feel
1372   # * our own cpufreq-detect.sh if /etc/init.d/loadcpufreq isn't present
1373   if ! cpufreq_check ; then
1374     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1375   else
1376      # Virtual Box supports ACPI and laptop-detect would return with '0', so check for it:
1377      if [ -r /proc/acpi/battery/BAT0/info ] ; then
1378         if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
1379            einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1380            return 0
1381         fi
1382      fi
1383      einfo "Trying to set up cpu frequency scaling:"
1384      eindent
1385      if [ -x /etc/init.d/loadcpufreq ] ; then
1386         SKIP_CPU_GOVERNOR=''
1387         LOADCPUFREQ=$(mktemp)
1388         /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1389         if grep -q FATAL "$LOADCPUFREQ" ; then
1390            eindent
1391              SKIP_CPU_GOVERNOR=1
1392              oldIFS="$IFS"
1393              IFS="
1394 "
1395               for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1396                   eerror "$line" ; eend $RC
1397               done
1398               IFS="$oldIFS"
1399            eoutdent
1400          elif grep -q done "$LOADCPUFREQ" ; then
1401            MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1402            if [ -n "$MODULE" -a "$MODULE" != none ]; then
1403               einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1404            else
1405               ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1406            fi
1407         fi
1408         rm -f $LOADCPUFREQ
1409      elif [ -r /usr/bin/cpufreq-detect.sh ] ; then
1410         . /usr/bin/cpufreq-detect.sh
1411         if [ -n "$MODULE" -a "$MODULE" != none ]; then
1412            einfo "Loading modules ${MODULE}"
1413            modprobe "$MODULE" >>$DEBUG || modprobe "$MODULE_FALLBACK" >>$DEBUG
1414            RC=$?
1415            if [[ "$RC" == 0 ]]; then
1416               eend 0
1417            else
1418               SKIP_CPU_GOVERNOR=1
1419               eend $RC
1420            fi
1421         else
1422            ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping."
1423            eend 1
1424         fi # $MODULE
1425      fi # loadcpufreq
1426
1427      if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1428         einfo "Loading cpufreq_ondemand, setting ondemand governor"
1429         RC=0
1430         if modprobe cpufreq_ondemand ; RC=$? ; then
1431            for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1432                echo ondemand > $file
1433            done
1434         fi
1435         eend $RC
1436      fi # cpu-governor
1437
1438      eoutdent
1439
1440   fi # cpufreq_check
1441 fi # checkbootparam nocpu
1442 }
1443 # }}}
1444
1445 # {{{ autostart of ssh
1446 config_ssh(){
1447 if checkbootparam 'ssh' ; then
1448    SSH_PASSWD=''
1449    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1450    einfo "Bootoption ssh found, trying to set password for user grml."
1451    eindent
1452    if [ -z "$SSH_PASSWD" ] ; then
1453       if [ -x /usr/bin/apg ] ; then
1454          SSH_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1455       elif [ -x /usr/bin/gpw ] ; then
1456          SSH_PASSWD="$(gpw 1)"
1457       elif [ -x /usr/bin/pwgen ] ; then
1458          SSH_PASSWD="$(pwgen -1 8)"
1459       elif [ -x /usr/bin/hexdump ] ; then
1460          SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1461       elif [ -n "$RANDOM" ] ; then
1462          SSH_PASSWD="grml${RANDOM}"
1463       else
1464          SSH_PASSWD=''
1465          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1466          eend 1
1467       fi
1468
1469       if [ -n "$SSH_PASSWD" ] ; then
1470          ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
1471       fi
1472    fi
1473    eoutdent
1474
1475    # finally check if we have a password we can use:
1476    if [ -n "$SSH_PASSWD" ] ; then
1477       # chpasswd sucks, seriously.
1478       if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
1479         echo "grml:$SSH_PASSWD" | chpasswd -m
1480       else
1481         echo "grml:$SSH_PASSWD" | chpasswd
1482       fi
1483    fi
1484
1485    einfo 'Starting secure shell server in background.'
1486    /etc/init.d/rmnologin start >>$DEBUG 2>>$DEBUG
1487    /etc/init.d/ssh start >>$DEBUG 2>>$DEBUG &
1488    eend $?
1489
1490    eindent
1491    ewarn 'Warning: please change the password for user grml as soon as possible!'
1492    eoutdent
1493 fi
1494 }
1495 # }}}
1496
1497 # {{{ autostart of x11vnc
1498 config_vnc(){
1499
1500 USER=grml # TODO: make it dynamically configurable
1501 if checkbootparam 'vnc' ; then
1502    VNC_PASSWD=''
1503    VNC_PASSWD="$(getbootparam 'vnc' 2>>$DEBUG)"
1504    einfo "Bootoption vnc found, trying to set password for user $USER."
1505    eindent
1506    if [ -z "$VNC_PASSWD" ] ; then
1507       if [ -x /usr/bin/apg ] ; then
1508          VNC_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1509       elif [ -x /usr/bin/gpw ] ; then
1510          VNC_PASSWD="$(gpw 1)"
1511       elif [ -x /usr/bin/pwgen ] ; then
1512          VNC_PASSWD="$(pwgen -1 8)"
1513       elif [ -x /usr/bin/hexdump ] ; then
1514          VNC_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1515       elif [ -n "$RANDOM" ] ; then
1516          VNC_PASSWD="${USER}${RANDOM}"
1517       else
1518          VNC_PASSWD=''
1519          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1520          eend 1
1521       fi
1522
1523       if [ -n "$VNC_PASSWD" ] ; then
1524          ewarn "No given password for vnc found. Using random password: $VNC_PASSWD" ; eend 0
1525       fi
1526    fi
1527    eoutdent
1528
1529    # finally check if we have a password we can use:
1530    if [ -n "$VNC_PASSWD" ] ; then
1531
1532       VNCDIR="/home/${USER}/.vnc"
1533       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1534
1535       if [ ! -x /usr/bin/x11vnc ] ; then
1536          eerror "Error: x11vnc not found - can not set up vnc. Please make sure to install the x11vnc package."
1537          eend 1
1538       else
1539          /usr/bin/x11vnc -storepasswd "$VNC_PASSWD" "$VNCDIR"/passwd ; eend $?
1540          /bin/chown -R "$USER": "$VNCDIR"
1541       fi
1542    fi
1543    if checkbootparam 'vnc_connect' ; then
1544       VNC_CONNECT=''
1545       VNC_CONNECT="$(getbootparam 'vnc_connect' 2>>$DEBUG)"
1546       einfo "Bootoption vnc_connect found, will start vnc with connect to $VNC_CONNECT."
1547       #store the options in a file
1548       VNCDIR="/home/${USER}/.vnc"
1549       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1550       echo " --connect $VNC_CONNECT " >> $VNCDIR/options
1551    fi
1552 fi
1553 }
1554 # }}}
1555
1556 # {{{ set password for user grml
1557 config_passwd(){
1558 if checkbootparam 'passwd' >>$DEBUG 2>&1; then
1559   einfo "Bootoption passwd found."
1560   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1561   if [ -n "$PASSWD" ] ; then
1562     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1563   else
1564     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1565   fi
1566   eindent
1567     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1568   eoutdent
1569 fi
1570 }
1571 # }}}
1572
1573 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1574 config_homedir(){
1575 if checkbootparam 'home' ; then
1576    ewarn "The \"home\" bootoption is deprecated, please use the persistency feature instead."; eend 1
1577 fi
1578 }
1579 # }}}
1580
1581 # {{{ Sound
1582
1583 config_mixer(){
1584 if ! [ -x /usr/bin/amixer ] ; then
1585   eerror "amixer binary not available. Can not set sound volumes therefore." ; eend 1
1586 else
1587
1588   if ! [ -r /proc/asound/cards ] ; then
1589      ewarn "No soundcard present, skipping mixer settings therefore." ; eend 0
1590      return
1591   fi
1592
1593   if checkbootparam 'vol' ; then
1594     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1595     if [ -z "$VOL" ] ; then
1596       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1597       VOL='75' # default
1598     fi
1599   else
1600     VOL='75' # default
1601   fi
1602
1603   if checkbootparam 'nosound' ; then
1604     einfo "Muting sound devices on request."
1605
1606     fix_ibm_sound 0
1607     # mute the master, this should be sufficient
1608     ERROR=$(amixer -q set Master mute)
1609     RC=$?
1610
1611     if [ -n "$ERROR" ] ; then
1612        eindent
1613        eerror "Problem muting sound devices: $ERROR"
1614        eoutdent
1615     fi
1616     eend $RC
1617   elif [ -z "$INSTALLED" ]; then
1618       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1619
1620       fix_ibm_sound ${VOL}
1621
1622       # by default assume '0' as volume for microphone:
1623       if checkbootparam 'micvol' ; then
1624          MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1625       else
1626          MICVOL=0
1627       fi
1628
1629       # finally set the volumes:
1630       RC=0
1631       for CONTROL in Master PCM ; do
1632          amixer -q set ${CONTROL} ${VOL}%
1633          if [ $? -ne 0 ] ; then RC=$? ; fi
1634       done
1635       # dont know how to set microphone volume for all soundcards with amixer,
1636       # so use aumix instead :/
1637       if [ ${MICVOL} -ne 0 -a -x /usr/bin/aumix ] ; then
1638          aumix -m $MICVOL &>/dev/null
1639          if [ $? -ne 0 ] ; then RC=$? ; fi
1640       fi
1641
1642       eend $RC
1643   fi
1644
1645 fi
1646 }
1647
1648 # on some IBM notebooks the front control has to be toggled
1649 fix_ibm_sound() {
1650  if [ -z $1 ] ; then
1651     return
1652  fi
1653
1654  VOL=${1}
1655
1656  if [ -x /usr/bin/amixer ] ; then
1657     if amixer -q get Front >/dev/null 2>>$DEBUG ; then
1658        amixer -q set Front unmute &>/dev/null
1659        amixer -q set Front ${VOL}% &>/dev/null
1660     fi
1661  fi
1662 }
1663 # }}}
1664
1665 # {{{ modem detection
1666 config_modem(){
1667 if checkbootparam 'nomodem'; then
1668   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1669 else
1670   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1671      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1672         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1673         eend 0
1674      fi
1675   fi
1676 fi
1677 }
1678 # }}}
1679
1680 # {{{ keyboard add-ons
1681 config_setkeycodes(){
1682 if checkbootparam 'setkeycodes' ; then
1683  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1684   # MS MM keyboard add-on
1685   # fix
1686   setkeycodes e001 126 &>/dev/null
1687   setkeycodes e059 127 &>/dev/null
1688   # fn keys
1689   setkeycodes e03b 59 &>/dev/null
1690   setkeycodes e008 60 &>/dev/null
1691   setkeycodes e007 61 &>/dev/null
1692   setkeycodes e03e 62 &>/dev/null
1693   setkeycodes e03f 63 &>/dev/null
1694   setkeycodes e040 64 &>/dev/null
1695   setkeycodes e041 65 &>/dev/null
1696   setkeycodes e042 66 &>/dev/null
1697   setkeycodes e043 67 &>/dev/null
1698   setkeycodes e023 68 &>/dev/null
1699   setkeycodes e057 87 &>/dev/null
1700   setkeycodes e058 88 &>/dev/null
1701   # hp keycodes
1702   setkeycodes e00a 89 e008 90 &>/dev/null
1703  eend 0
1704 fi
1705 }
1706 # }}}
1707
1708 # {{{ wondershaper
1709 config_wondershaper(){
1710  if checkbootparam 'wondershaper' ; then
1711     WONDER="$(getbootparam 'wondershaper' 2>>$DEBUG)"
1712     CMD=wondershaper
1713     DEVICE=""
1714     DOWNSTREAM=""
1715     UPSTREAM=""
1716     if [ -n "$WONDER" ]; then
1717       # Extra options
1718       DEVICE="${WONDER%%,*}"
1719       R="${WONDER#*,}"
1720       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1721         WONDER="$R"
1722         DOWNSTREAM="${WONDER%%,*}"
1723         R="${WONDER#*,}"
1724         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1725           WONDER="$R"
1726           UPSTREAM="${WONDER%%,*}"
1727           R="${WONDER#*,}"
1728         fi
1729       fi
1730     fi
1731     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1732     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1733     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1734     einfo "Starting wondershaper (${CMD}) in background."
1735     ( sh -c $CMD & ) && eend 0
1736  fi
1737 }
1738 # }}}
1739
1740 # {{{ syslog-ng
1741 config_syslog(){
1742  if checkbootparam 'nosyslog'; then
1743     ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
1744  else
1745     SYSLOGD=''
1746     [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
1747     [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
1748     [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
1749     [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
1750     [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
1751
1752     if [ -z "$SYSLOGD" ] ; then
1753        eerror "No syslog daemon found." ; eend 1
1754     else
1755        einfo "Starting $SYSLOGD in background."
1756        /etc/init.d/$SYSLOGD start >>$DEBUG &
1757        eend 0
1758     fi
1759  fi
1760 }
1761 # }}}
1762
1763 # {{{ gpm
1764 config_gpm(){
1765  if checkbootparam 'nogpm'; then
1766   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1767  else
1768    if ! [ -r /dev/input/mice ] ; then
1769       eerror "No mouse found - not starting GPM." ; eend 1
1770    else
1771       einfo "Starting gpm in background."
1772       /etc/init.d/gpm start >>$DEBUG &
1773       # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start >>$DEBUG ) &
1774       eend 0
1775    fi
1776  fi
1777 }
1778 # }}}
1779
1780 # {{{ services
1781 config_services(){
1782  if checkbootparam 'services' ; then
1783     SERVICE="$(getbootparam 'services' 2>>$DEBUG)"
1784     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1785     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1786     einfo "Starting service(s) ${SERVICENL} in background."
1787     for service in $(echo -e $SERVICELIST) ; do
1788        /etc/init.d/${service} start >>$DEBUG &
1789     done
1790     [ "$?" == "0" ] ; eend $?
1791  fi
1792 }
1793 # }}}
1794
1795 # {{{ remote files
1796 get_remote_file() {
1797   [ "$#" -eq 2 ] || ( echo "Error: wrong parameter for get_remote_file()" ; return 1 )
1798   SOURCE=$(eval echo "$1")
1799   TARGET="$2"
1800   getconfig() {
1801   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 --tries=1 \
1802        --read-timeout=10 ${SOURCE} -O ${TARGET} && return 0 || return 1
1803   }
1804   einfo "Trying to get ${WHITE}${TARGET}${NORMAL}"
1805   counter=10
1806   while ! getconfig && [[ "$counter" != 0 ]] ; do
1807     echo -n "Sleeping for 1 second and trying to get config again... "
1808     counter=$(( counter-1 ))
1809     echo "$counter tries left" ; sleep 1
1810   done
1811   if [ -s "$TARGET" ] ; then
1812     einfo "Downloading was successfull." ; eend 0
1813     einfo "md5sum of ${WHITE}${TARGET}${NORMAL}: "
1814     md5sum ${TARGET} ; eend 0
1815     return 0;
1816   else
1817     einfo "Sorry, could not fetch ${SOURCE}" ; eend 1
1818     return 1;
1819  fi
1820 }
1821 # }}}
1822
1823 # {{{ config files
1824 config_netconfig(){
1825  if checkbootparam 'netconfig' ; then
1826   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1827   CONFIGFILE='/tmp/netconfig.grml'
1828
1829   if get_remote_file ${CONFIG} ${CONFIGFILE} ; then
1830     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1831   fi
1832
1833  fi
1834 }
1835 # }}}
1836
1837 # {{{ remote scripts
1838 config_netscript() {
1839  if checkbootparam 'netscript' ; then
1840   CONFIG="$(getbootparam 'netscript' 2>>$DEBUG)"
1841   SCRIPTFILE='/tmp/netscript.grml'
1842
1843   if get_remote_file ${CONFIG} ${SCRIPTFILE} ; then
1844     chmod +x ${SCRIPTFILE}
1845     einfo "Running ${WHITE}${SCRIPTFILE}${NORMAL}:" && NETSCRIPT=${CONFIG} ${SCRIPTFILE} ; eend $?
1846   fi
1847
1848  fi
1849 }
1850 # }}}
1851
1852 # {{{ blindsound
1853 config_blindsound(){
1854  if checkbootparam 'blind' ; then
1855     beep
1856     flitewrapper "welcome to the gremel system"
1857  fi
1858 }
1859 # }}}
1860
1861 # {{{ welcome sound
1862 config_welcome(){
1863  if checkbootparam 'welcome' ; then
1864     flitewrapper "welcome to the gremel system"
1865  fi
1866 }
1867 # }}}
1868
1869 # {{{ fix/workaround for unionfs
1870 fix_unionfs(){
1871   if [ -z "$INSTALLED" ]; then
1872    touch /var/cache/apt/*cache.bin
1873   fi
1874 }
1875 # }}}
1876
1877 # {{{ create all /mnt-directories
1878 create_mnt_dirs(){
1879   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1880   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1881 }
1882 # }}}
1883
1884 # {{{ start X window system via grml-x
1885 config_x_startup(){
1886 # make sure we start X only if startx is used *before* a nostartx option
1887 # so it's possible to disable automatic X startup using nostart
1888 if checkbootparam 'startx' && ! echo "$CMDLINE" | grep -q 'startx.*nostartx' ; then
1889  if [ -x $(which X) ] ; then
1890   if [ -z "$INSTALLED" ] ; then
1891    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1892    if [ -z "$WINDOWMANAGER" ] ; then
1893      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1894      WINDOWMANAGER="wm-ng"
1895    else
1896      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1897    fi
1898    einfo "Setting up and invoking grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1899    config_userfstab || fstabuser='grml'
1900  cat>|/etc/init.d/xstartup<<EOF
1901 #!/bin/sh
1902 su $fstabuser -c "/usr/bin/grml-x $WINDOWMANAGER"
1903 EOF
1904    chmod 755 /etc/init.d/xstartup
1905
1906    # adjust inittab for xstartup
1907    if grep -q '^6:' /etc/inittab ; then
1908       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>\&1 </dev/tty6|' /etc/inittab
1909    else # just append tty6 to inittab if no definition is present:
1910       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>&1 < /dev/tty6' >> /etc/inittab
1911    fi
1912
1913    /sbin/telinit q ; eend $?
1914
1915    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1916       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1917    else
1918       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1919    fi
1920
1921   else
1922     eerror "We are not running in live mode - startx will not work, skipping it."
1923     eerror " -> Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1924   fi
1925  else
1926    eerror "/usr/X11R6/bin/X is not present on this grml flavour."
1927    eerror "  -> Boot parameter startx does not work therefore." ; eend 1
1928  fi
1929 fi
1930 }
1931 # }}}
1932
1933 # {{{ configuration framework
1934 config_extract(){
1935 if checkbootparam 'extract' ; then
1936  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1937  EXTRACTOPTIONS="-- -x $EXTRACT"
1938 fi
1939 }
1940
1941 config_finddcsdir() {
1942 #  - If no GRMLCFG partition is found and noautoconfig is _not_ given
1943 #    on the command line, nothing is changed and the dcs files are
1944 #    searched within the .iso, $dcs-dir is set to the root directory
1945 #    within the .iso
1946 #  - If a GRMLCFG partition is found, $dcs-dir is set to the root of
1947 #    the GRMLCFG partition unless noautoconfig is set. If noautoconfig is
1948 #    set, $dcs-dir is set to the root directory within the .iso.
1949 #  - If myconfig=foo is set on the command line, $dcs-dir is set to
1950 #    foo, even if a GRMLCFG partition is present.
1951 DCSDIR=""
1952 DCSMP="/mnt/grml"
1953 if checkbootparam 'noautoconfig' || checkbootparam 'forensic' ; then
1954   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1955 else
1956   if [ -z "$INSTALLED" ] ; then
1957     if checkbootparam 'myconfig' ; then
1958       DCSDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1959       if [ -z "$DCSDEVICE" ]; then
1960         eerror "Error: No device for bootoption myconfig provided." ; eend 1
1961       fi # [ -z "$DCSDEVICE" ]
1962     elif checkvalue $CONFIG_MYCONFIG; then # checkbootparam myconfig
1963       einfo "Searching for device(s) labeled with GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
1964       eindent
1965       # We do need the following fix so floppy disk is available to blkid in any case :-/
1966       if [ -r /dev/fd0 ] ; then
1967         einfo "Floppy device detected. Trying to access floppy disk."
1968         if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 >>$DEBUG 2>&1 ; then
1969            blkid /dev/fd0 >>$DEBUG 2>&1
1970         fi
1971       fi
1972       DCSDEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1973       if [ -n "$DCSDEVICE" ]; then
1974         DCSMP="/mnt/grmlcfg"
1975       fi
1976       eoutdent
1977     fi
1978
1979     # if not specified/present then assume default:
1980     if [ -z "$DCSDEVICE" ]; then
1981       DCSDIR="/live/image"
1982     else
1983       eindent
1984       einfo "debs, config, scripts are read from $DCSDEVICE." ; eend 0
1985       DCSDIR="$(< /proc/mounts awk -v DCSDEV=$DCSDEVICE '{if ($1 == DCSDEV) { print $2 }}')"
1986       if [ -n "$DCSDIR" ]; then
1987         ewarn "$DCSDEVICE already mounted on $DCSDIR"; eend 0
1988       else
1989         [ -d $DCSMP ] || mkdir $DCSMP
1990         umount $DCSMP >>$DEBUG 2>&1 # make sure it is not mounted
1991         mount -o ro -t auto $DCSDEVICE  $DCSMP ; RC="$?"
1992         if [[ $RC == 0 ]]; then
1993           einfo "Successfully mounted $DCSDEVICE to $DCSMP (readonly)." ; eend 0
1994         else
1995           eerror "Error: mounting $DCSDEVICE to $DCSMP (readonly) failed." ; eend 1
1996         fi
1997         DCSDIR="$DCSMP"
1998       fi
1999       eoutdent
2000     fi
2001   fi
2002 fi
2003
2004 if [ -n "$DCSDIR" -a "$DCSDIR" != "/live/image" ] ; then
2005   einfo "Debs, config, scripts (if present) will be read from $DCSDIR." ; eend 0
2006 elif checkbootparam 'debs' || checkbootparam 'config' || checkbootparam 'scripts'; then
2007   einfo "Debs, config, scripts will be read from the live image directly." ; eend 0
2008 fi
2009 }
2010
2011
2012 config_partconf() {
2013 if checkbootparam 'partconf' ; then
2014  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
2015  if [ -n "$MOUNTDEVICE" ]; then
2016    [ -d /mnt/grml ] || mkdir /mnt/grml
2017    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
2018     if [[ $RC == 0 ]]; then
2019       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
2020       einfo "Copying files from $MOUNTDEVICE over grml system."
2021       for file in `cat /etc/grml/partconf` ; do
2022         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
2023         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
2024       done && eend 0
2025     else
2026       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
2027     fi # mount $MOUNTDEVICE
2028    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
2029  else
2030    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
2031  fi # [ -n "$MOUNTDEVICE" ]
2032 fi
2033 }
2034 # }}}
2035
2036 # {{{ /cdrom/.*-options
2037 config_debs(){
2038 if checkbootparam 'debs' ; then
2039    iszsh && setopt localoptions shwordsplit
2040    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
2041    if ! echo $DEBS | grep -q '/'; then
2042      # backwards compatibility: if no path is given get debs from debs/
2043      DEBS="debs/$DEBS"
2044    fi
2045    einfo "Tring to install debian package(s) ${DEBS}"
2046    DEBS="$(eval echo ${DCSDIR}/$DEBS)"
2047    dpkg -i $DEBS ; eend $?
2048 fi
2049 }
2050
2051 config_scripts(){
2052 if checkbootparam 'scripts' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2053    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
2054    if [ -d ${DCSDIR}/scripts ] && [ -z "$SCRIPTS" ]; then
2055      SCRIPTS="$(cd ${DCSDIR}/scripts; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
2056    fi
2057    if ! echo $SCRIPTS | grep -q '/'; then
2058      # backwards compatibility: if no path is given get scripts from scripts/
2059      SCRIPTS="scripts/$SCRIPTS"
2060    fi
2061    if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2062      # we are executing from a GRMLCFG labeled fs
2063      # kick everything we have done before and start over
2064      SCRIPTS="$(cd ${DCSDIR}; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
2065    fi
2066    if [ -n "$SCRIPTS" ]; then
2067      SCRIPTS="${DCSDIR}/$SCRIPTS"
2068      if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2069        einfo "Trying to execute ${SCRIPTS}"
2070        sh -c $SCRIPTS
2071      elif [ -d "$SCRIPTS" ]; then
2072        einfo "Bootparameter scripts found. Trying to execute from directory ${SCRIPTS}:"
2073        run-parts $SCRIPTS
2074      else
2075        einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
2076        sh -c $SCRIPTS
2077      fi
2078    fi
2079 fi
2080 }
2081
2082 config_config(){
2083 if checkbootparam 'config' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2084   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
2085   if [ -z "$CONFIG" ]; then
2086     CONFIG="$(cd ${DCSDIR}; ls -1d [Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
2087   fi
2088   if [ -n "$CONFIG" ]; then
2089     if [ -d "${DCSDIR}/${CONFIG}" ] ; then
2090       einfo "Taking configuration from directory ${DCSDIR}/${CONFIG}"
2091
2092       cp -a ${DCSDIR}/${CONFIG}/* /
2093     elif [ -f "${DCSDIR}/${CONFIG}" ]; then
2094       einfo "Extracting configuration from file ${DCSDIR}/${CONFIG}"
2095
2096       cd /
2097       unp ${DCSDIR}/${CONFIG} $EXTRACTOPTIONS ; eend $?
2098     else
2099       ewarn "Sorry, could not find configuration file or directory ${DCSDIR}/${FILENAME}." ; eend 1
2100     fi
2101   fi
2102 fi
2103 # umount $DCSMP if it was mounted by finddcsdir
2104 # this doesn't really belong here
2105 grep -q '$DCSMP' /proc/mounts && umount $DCSMP
2106 }
2107 # }}}
2108
2109 # {{{ mypath
2110 config_mypath(){
2111 if checkbootparam 'mypath' ; then
2112    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
2113    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
2114    touch /etc/grml/my_path
2115    chmod 644 /etc/grml/my_path
2116    # make sure the directories exist:
2117    eindent
2118    for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
2119        if ! [ -d "$i" ] ; then
2120           einfo "Creating directory $i"
2121           mkdir -p "$i" ; eend $?
2122        fi
2123    done
2124    grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
2125    eoutdent
2126 fi
2127 }
2128 # }}}
2129
2130 # {{{ distcc
2131 config_distcc(){
2132 if checkbootparam 'distcc' ; then
2133  OPTIONS="$(getbootparam 'distcc' 2>>$DEBUG)"
2134  if [ -n "$OPTIONS" ]; then
2135     NET=""
2136     INTERFACE=""
2137     if [ -n "$OPTIONS" ]; then
2138       NET="${OPTIONS%%,*}"
2139       R="${OPTIONS#*,}"
2140       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2141         OPTIONS="$R"
2142         INTERFACE="${OPTIONS%%,*}"
2143         R="${OPTIONS#*,}"
2144       fi
2145     fi
2146  fi
2147  CONFIG=/etc/default/distcc
2148  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
2149  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
2150
2151  if [ -n "$INTERFACE" ] ; then
2152    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2153
2154    counter=10
2155    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
2156      counter=$(( counter-1 ))
2157      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
2158      sleep 3
2159      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2160    done
2161  fi
2162
2163  if [ -n "$IP" ] ; then
2164    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
2165
2166    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
2167    eindent
2168     id distccd >/dev/null 2>&1 || \
2169     (
2170       einfo "Creating distcc user" ; \
2171       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
2172     )
2173
2174     einfo "Starting distcc for network ${NET}, listening on ${IP}."
2175    /etc/init.d/distcc start >/dev/null ; eend $?
2176    eoutdent
2177  else
2178    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
2179  fi
2180 fi
2181
2182 if checkbootparam 'gcc'; then
2183  GCC="$(getbootparam 'gcc' 2>>$DEBUG)"
2184  eindent
2185  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
2186  eoutdent
2187  rm -f /usr/bin/gcc
2188  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
2189 fi
2190
2191 if checkbootparam 'gpp'; then
2192  GPP="$(getbootparam 'gpp' 2>>$DEBUG)"
2193  eindent
2194   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
2195   if [ -x /usr/bin/g++-${GPP} ] ; then
2196      rm -f /usr/bin/g++
2197      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
2198   fi
2199   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
2200   if [ -x /usr/bin/cpp-${GPP} ] ; then
2201      rm -f /usr/bin/cpp
2202      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
2203   fi
2204  eoutdent
2205 fi
2206
2207 }
2208 # }}}
2209
2210 # {{{ load modules
2211 # Notice: use it only on live-cd system, if running from harddisk please
2212 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2213 # in /etc/runlevel.conf
2214 config_modules(){
2215 MODULES_FILE=/etc/grml/modules
2216 if checkbootparam 'nomodules' ; then
2217   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2218 elif [ -z "$INSTALLED" ]; then
2219  if [ -r $MODULES_FILE ] ; then
2220   einfo "Loading modules specified in ${MODULES_FILE}:"
2221   eindent
2222   grep '^[^#]' $MODULES_FILE | \
2223   while read module args; do
2224     [ "$module" ] || continue
2225       einfo "${module}"
2226       modprobe $module $args ; eend $?
2227   done
2228   eoutdent
2229  else
2230   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2231  fi
2232 fi
2233 }
2234 # }}}
2235
2236 # {{{ 915resolution
2237 config_915resolution(){
2238 if checkbootparam '915resolution' ; then
2239  OPTIONS="$(getbootparam '915resolution' 2>>$DEBUG)"
2240   if [ -x /usr/sbin/915resolution ]; then
2241     CMD=915resolution
2242     MODE=""
2243     XRESO=""
2244     YRESO=""
2245     if [ -n "$OPTIONS" ]; then
2246       # Extra options
2247       MODE="${OPTIONS%%,*}"
2248       R="${OPTIONS#*,}"
2249       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2250         OPTIONS="$R"
2251         XRESO="${OPTIONS%%,*}"
2252         R="${OPTIONS#*,}"
2253         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2254           OPTIONS="$R"
2255           YRESO="${OPTIONS%%,*}"
2256           R="${OPTIONS#*,}"
2257         fi
2258       fi
2259     fi
2260     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2261     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2262     eend 0
2263   fi
2264 fi
2265 }
2266 # }}}
2267
2268 # {{{ SW-RAID
2269 config_swraid(){
2270   [ -n "$INSTALLED" ] && return 0
2271
2272   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2273   if checkbootparam 'noraid'   || checkbootparam 'noswraid' || \
2274      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2275      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2276   else
2277     if ! [ -x /sbin/mdadm ] ; then
2278        eerror "mdadm not available, can not execute it." ; eend 1
2279     else
2280
2281        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2282        # find out whether we have a valid configuration file already
2283        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2284           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2285           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2286           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2287         else
2288           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2289        fi
2290
2291        if ! checkbootparam 'swraid' ; then
2292           eindent
2293           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2294           eoutdent
2295        else
2296           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2297           eindent
2298            IFSOLD=${IFS:-}
2299            IFS='
2300 '
2301            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2302                case $line in
2303                  *'No arrays found'*)
2304                    ewarn "$line" ; eend 0
2305                    ;;
2306                  *)
2307                    einfo "$line" ; eend 0
2308                    ;;
2309                esac
2310            done
2311            IFS=$IFSOLD
2312          eoutdent
2313
2314          if [ -r /proc/mdstat ] ; then
2315             eindent
2316             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2317             if [ -z "$MDSTAT" ] ; then
2318                ewarn "No active arrays found" ; eend 0
2319             else
2320                IFSOLD=${IFS:-}
2321                IFS='
2322 '
2323                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2324                    einfo "active arrays: $line" ; eend 0
2325                done
2326                IFS=$IFSOLD
2327             fi
2328             eoutdent
2329          fi # /proc/mdstat
2330        fi # bootoption swraid
2331
2332      fi # is /sbin/mdadm executable?
2333   fi # check for bootoptions
2334 }
2335 # }}}
2336
2337 # {{{ dmraid
2338 config_dmraid(){
2339   [ -n "$INSTALLED" ] && return 0
2340
2341   if checkbootparam 'nodmraid' ; then
2342     ewarn "Skipping dmraid code as requested on boot commandline." ; eend 0
2343     return 0
2344   fi
2345
2346   if ! [ -x /sbin/dmraid ] ; then
2347     eerror "dmraid not available, can not execute it." ; eend 1
2348     return
2349   fi
2350
2351   dmraid_wrapper() {
2352     # usage: dmraid_wrapper <dmraid_option>
2353     [ -n "$1" ] || return 1
2354
2355     IFSOLD=${IFS:-}
2356     IFS='
2357 '
2358     eindent
2359
2360     for line in $(dmraid $1 ; echo errcode:$?); do
2361       case $line in
2362         *'no block devices found'*)
2363           einfo "No block devices found" ; eend 0
2364           break
2365           ;;
2366         *'no raid disks'*)
2367           einfo "No active dmraid devices found" ; eend 0
2368           break
2369           ;;
2370         errcode:0)
2371           eend 0;
2372           ;;
2373         errcode:1)
2374           eend 1
2375           ;;
2376         *)
2377           einfo "$line"
2378           ;;
2379       esac
2380     done
2381
2382     eoutdent
2383     IFS=$IFSOLD
2384   }
2385
2386   if checkbootparam 'dmraid' ; then
2387     local ACTION="$(getbootparam 'dmraid' 2>>$DEBUG)"
2388     if [ "$ACTION" = "off" ] ; then
2389       # Deactivates all active software RAID sets:
2390       einfo "Deactivating present dmraid sets (as requested via dmraid=off):"
2391       dmraid_wrapper -an
2392     else
2393       # Activate all software RAID sets discovered:
2394       einfo "Activating present dmraid sets (as requested via dmraid):"
2395       dmraid_wrapper -ay
2396     fi
2397
2398     return
2399   fi
2400
2401   # by default (no special bootoptions) discover all software RAID devices:
2402   einfo "Searching for any present dmraid sets:"
2403   dmraid_wrapper -r
2404 }
2405 # }}}
2406
2407 # {{{ LVM (Logical Volumes)
2408 config_lvm(){
2409   [ -n "$INSTALLED" ] && return 0
2410
2411   if checkbootparam 'nolvm' ; then
2412      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2413   else
2414     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2415     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2416        eerror "LVM not available, can not execute it." ; eend 1
2417     else
2418        if lvdisplay 2>&1 | grep -v 'No volume groups found' >/dev/null 2>&1 ; then
2419           einfo "You seem to have logical volumes (LVM) on your system."
2420           eindent
2421           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2422           eend 0
2423           if checkbootparam 'lvm' ; then
2424              einfo "Bootoption LVM found. Searching for logical volumes:"
2425              /etc/init.d/lvm2 start ; eend $?
2426           fi
2427           eoutdent
2428        fi
2429     fi # check for lvm binary
2430   fi # check for bootoption nolvm
2431 }
2432 # }}}
2433
2434 # {{{ debnet: setup network based on an existing one found on a partition
2435 config_debnet(){
2436 if checkbootparam 'debnet' ; then
2437  iszsh && setopt localoptions shwordsplit
2438  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2439  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2440  FOUND_DEBNET=""
2441
2442  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2443  eindent
2444  if ! mount | grep '/mnt ' >/dev/null 2>&1 ; then
2445     for i in $DEVICES; do
2446      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2447          einfo "Scanning on $i"
2448        if [ -f /mnt/etc/network/interfaces ]; then
2449          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2450          FOUND_DEBNET="$i"
2451          break
2452        fi
2453        umount /mnt
2454      fi
2455     done
2456
2457    if [ -n "$FOUND_DEBNET" ]; then
2458      einfo "Stopping network."
2459        pump -k >/dev/null 2>&1
2460        /etc/init.d/networking stop >/dev/null 2>&1 ; eend $?
2461      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2462        rm -rf /etc/network/run
2463        cp -a /mnt/etc/network /etc
2464        rm -rf /etc/network/run
2465        mkdir /etc/network/run
2466        umount /mnt ; eend $?
2467      einfo "Starting network."
2468        invoke-rc.d networking start ; eend $?
2469    else
2470      eerror "/etc/network/interfaces not found." ; eend 1
2471    fi
2472    eoutdent
2473  else
2474   eerror "Error: /mnt already mounted." ; eend 1
2475  fi
2476 fi
2477 }
2478 # }}}
2479
2480 # {{{ check for broken ipw3945 driver which causes problems (especially on hd install)
2481 config_ipw3945() {
2482   if grep -q ipw3945 /proc/modules ; then
2483      if ! iwconfig 2>/dev/null| grep -qe 'IEEE 802' -qe 'unassociated' ; then
2484         ewarn "Broken ipw3945 network interface found, reloading module."
2485         rmmod ipw3945
2486         modprobe ipw3945
2487         eend $?
2488      fi
2489   fi
2490 }
2491 # }}}
2492
2493 # {{{ disable console blanking
2494 config_blanking(){
2495 if checkbootparam 'noblank' ; then
2496   einfo "Bootoption noblank found. Disabling monitor blanking."
2497   setterm -blank 0 ; eend $?
2498 fi
2499 }
2500 # }}}
2501
2502 # {{{ tohd= bootoption
2503 config_tohd()
2504 {
2505   if checkbootparam 'tohd' ; then
2506      local TARGET="$(getbootparam 'tohd' 2>>$DEBUG)"
2507      if [ -z "$TARGET" ] ; then
2508         eerror "Error: tohd specified without any partition, can not continue." ; eend 1
2509         eerror "Please use something like tohd=/dev/sda9." ; eend 1
2510         return 1
2511      fi
2512
2513      if ! [ -b "$TARGET" ] ; then
2514         eerror "Error: $TARGET is not a valid block device, sorry." ; eend 1
2515         return 1
2516      fi
2517
2518      if grep -q $TARGET /proc/mounts ; then
2519         eerror "$TARGET already mounted, skipping execution of tohd therefore."
2520         eend 1
2521         return 1
2522      fi
2523
2524      local MOUNTDIR=$(mktemp -d)
2525
2526      if mount -o rw "$TARGET" "$MOUNTDIR" ; then
2527         einfo "Copyring live system to $TARGET - this might take a while"
2528         rsync -a --progress /live/image/live $MOUNTDIR
2529         sync
2530         umount "$MOUNTDIR"
2531         eend $?
2532         einfo "Booting with \"grml bootfrom=$TARGET\" should work now." ; eend 0
2533      else
2534         eerror "Error when trying to mount $TARGET, sorry."; eend 1
2535         return 1
2536      fi
2537
2538      rmdir "$MOUNTDIR"
2539   fi
2540 }
2541 # }}}
2542
2543 # {{{ grml2hd: automatic installation
2544 config_grml2hd(){
2545
2546 if checkbootparam "BOOT_IMAGE=grml2hd" ; then
2547
2548 if checkbootparam 'user' ; then
2549    NEWUSER=''
2550    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2551    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2552 fi
2553
2554 if checkbootparam 'filesystem' ; then
2555    FILESYSTEM=''
2556    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2557    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2558 fi
2559
2560 if checkbootparam 'partition' ; then
2561    PARTITION=''
2562    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2563    # notice: the following checks whether the given partition is available, if not the skip
2564    # execution of grml2hd as it might result in data loss...
2565    if [ -r $PARTITION ] ; then
2566       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2567    else
2568       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2569    fi
2570 fi
2571
2572 if checkbootparam 'mbr' ; then
2573    BOOT_PARTITION=''
2574    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2575    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2576 fi
2577
2578 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2579 #!/bin/sh
2580 GRML2HD_NONINTERACTIVE='yes' grml2hd
2581 EOF
2582
2583 chmod 755 /usr/bin/grml2hd_noninteractive
2584 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2585 if [ -z "$GRML2HD_FAIL" ] ; then
2586    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2587 else
2588    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2589 fi
2590
2591 fi # if checkbootparam "BOOT_IMAGE=grml2hd ...
2592 }
2593 # }}}
2594
2595 # {{{ debootstrap: automatic installation
2596 config_debootstrap(){
2597
2598 if checkbootparam "BOOT_IMAGE=debian2hd" ; then
2599
2600 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2601
2602 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2603    eindent
2604    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2605    eoutdent
2606    exit 1
2607 fi
2608
2609 if checkbootparam 'target' ; then
2610   TARGET=''
2611   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2612   # notice: the following checks whether the given partition is available, if not the skip
2613   # execution of grml-debootstrap as it might result in data loss...
2614   if ! [ -r "$TARGET" ] ; then
2615      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2616   fi
2617 else
2618   eindent
2619   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2620   eoutdent
2621   exit 1
2622 fi
2623
2624 if checkbootparam 'grub' ; then
2625   GRUB=''
2626   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2627 fi
2628
2629 if checkbootparam 'groot' ; then
2630   GROOT=''
2631   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2632 fi
2633
2634 if checkbootparam 'release' ; then
2635   RELEASE=''
2636   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2637 fi
2638
2639 if checkbootparam 'mirror' ; then
2640   MIRROR=''
2641   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2642 fi
2643
2644 if checkbootparam 'boot_append' ; then
2645   BOOT_APPEND=''
2646   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2647 fi
2648
2649 if checkbootparam 'password' ; then
2650   PASSWORD=''
2651   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2652 fi
2653
2654 # now check which options are available
2655 if [ -n "TARGET" ] ; then
2656    TARGETCMD="--target $TARGET"
2657 else
2658    TARGETCMD=''
2659    eindent
2660    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2661    eoutdent
2662    exit 1
2663 fi
2664 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2665 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2666 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2667 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2668 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2669 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2670
2671 # and finally write script and execute it
2672 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2673 #!/bin/sh
2674 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2675 EOF
2676
2677 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2678
2679 screen /usr/bin/grml-debootstrap_noninteractive
2680 einfo "Invoking a shell, just exit to continue booting..."
2681 /bin/zsh
2682
2683 fi # checkbootparam "BOOT_IMAGE=debian2hd
2684 }
2685 # }}}
2686
2687 # {{{ Support customization
2688 config_distri(){
2689 if checkbootparam 'distri'; then
2690   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2691   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2692      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2693      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2694      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2695      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2696   fi
2697 fi
2698 }
2699 # }}}
2700
2701 ### {{{ backwards compatible stuff
2702 config_environment(){
2703   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2704 }
2705 config_keyboard(){
2706   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2707 }
2708 # }}}
2709
2710 ## END OF FILE #################################################################
2711 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3